com.tibbo.aggregate.common.context

## Class ContextUtils

- java.lang.Object
- - com.tibbo.aggregate.common.context.ContextUtils

-     public class ContextUtils
      extends java.lang.Object

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `ContextUtils.ModifyVariable`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `CONTEXT_GROUP_MASK`
    `static java.lang.String` | `CONTEXT_MASK_PATTERN`
    `static java.lang.String` | `CONTEXT_NAME_PATTERN`
    `static java.lang.String` | `CONTEXT_NAME_SEPARATOR`
    `static java.lang.String` | `CONTEXT_PATH_PATTERN`
    `static java.lang.String` | `CONTEXT_TYPE_ANY`
    `static java.lang.String` | `CONTEXT_TYPE_PATTERN`
    `static java.lang.String` | `CONTEXT_TYPE_SEPARATOR`
    `static java.util.Set<java.lang.String>` | `CONTEXT_TYPES`
    `static int` | `ENTITY_ACTION`
    `static int` | `ENTITY_ACTION_GROUP`
    `static java.lang.String` | `ENTITY_ANY`
    `static int` | `ENTITY_ANY_TYPE`
    `static int` | `ENTITY_EVENT`
    `static int` | `ENTITY_EVENT_GROUP`
    `static int` | `ENTITY_FUNCTION`
    `static int` | `ENTITY_FUNCTION_GROUP`
    `static java.lang.String` | `ENTITY_GROUP_MASK`
    `static java.lang.String` | `ENTITY_GROUP_SEPARATOR`
    `static int` | `ENTITY_GROUP_SHIFT`
    `static java.lang.String` | `ENTITY_GROUP_SUFFIX`
    `static int` | `ENTITY_INSTANCE`
    `static java.lang.String` | `ENTITY_NAME_PATTERN`
    `static int` | `ENTITY_VARIABLE`
    `static int` | `ENTITY_VARIABLE_GROUP`
    `static java.lang.String` | `GROUP_ACCESS`
    `static java.lang.String` | `GROUP_CONTEXT_DATA`
    `static java.lang.String` | `GROUP_CUSTOM`
    `static java.lang.String` | `GROUP_DEFAULT`
    `static java.lang.String` | `GROUP_REMOTE`
    `static java.lang.String` | `GROUP_STATUS`
    `static java.lang.String` | `GROUP_SYSTEM`
    `static java.lang.String` | `IDENTIFIER_PATTERN`
    `static java.lang.String` | `MASK_LIST_SEPARATOR`
    `static java.util.Set<java.lang.String>` | `RESERVED_CONTEXT_NAMES`
    `static java.lang.String` | `SRV_MORE_CONTEXT`
    `static java.lang.String` | `USERNAME_PATTERN`
    `static java.lang.String` | `VARIABLES_GROUP_DS_SETTINGS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ContextUtils()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `alertContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `alertsContextPath(java.lang.String owner)`
    `static java.lang.String` | `applicationContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `applicationsContextPath(java.lang.String owner)`
    `static java.lang.String` | `applicationsContextPathByUserContext(java.lang.String userContextPath)`
    `static java.lang.String` | `autorunActionContextName(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `autorunActionsContextPath(java.lang.String owner)`
    `static void` | `changeVariable(Context aContext, java.lang.String variableNameString, ContextUtils.ModifyVariable modifications)`
    `static java.lang.String` | `classContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `classesContextPath(java.lang.String owner)`
    `static java.lang.String` | `commonDataContextPath(java.lang.String owner)`
    `static java.lang.String` | `commonTableContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `compliancePoliciesContextPath(java.lang.String owner)`
    `static java.lang.String` | `compliancePolicyContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `contextPathToContextName(java.lang.String path)`
    `static java.lang.String` | `createGroup(java.lang.String... parts)`
    `static java.lang.String` | `createName(java.lang.String... parts)`
    `static java.lang.String` | `createType(java.lang.Class clazz, java.lang.String deviceType)`
    `static java.lang.String` | `dashboardContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `dashboardsContextPath(java.lang.String owner)`
    `static java.lang.String` | `deviceContextPath(java.lang.String owner, java.lang.String device)`
    `static java.lang.String` | `deviceGroupContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `deviceGroupsContextPath(java.lang.String owner)`
    `static java.lang.String` | `devicesContextPath(java.lang.String owner)`
    `static java.lang.String` | `deviceServerContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `deviceServersContextPath(java.lang.String owner)`
    `static java.lang.String` | `dsGroupContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `dsGroupsContextPath(java.lang.String owner)`
    `static java.lang.String` | `eventCorrelatorContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `eventCorrelatorsContextPath(java.lang.String owner)`
    `static java.lang.String` | `eventFilterContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `eventFiltersContextPath(java.lang.String owner)`
    `static java.util.List<Context>` | `expandMaskListToContexts(java.lang.String masks, ContextManager contextManager)`
    `static java.util.List<Context>` | `expandMaskListToContexts(java.lang.String masks, ContextManager contextManager, CallerController caller)`
    `static java.util.List<Context>` | `expandMaskListToContexts(java.lang.String masks, ContextManager contextManager, CallerController caller, boolean useVisibleChildren)`
    `static java.util.List<Context>` | `expandMaskToContexts(java.lang.String mask, ContextManager contextManager)`
    `static java.util.List<Context>` | `expandMaskToContexts(java.lang.String mask, ContextManager contextManager, CallerController caller)`
    `static java.util.List<Context>` | `expandMaskToContexts(java.lang.String mask, ContextManager contextManager, CallerController caller, boolean useVisibleChildren)`
    `static java.util.List<java.lang.String>` | `expandMaskToPaths(java.lang.String mask, ContextManager contextManager)`
    `static java.util.List<java.lang.String>` | `expandMaskToPaths(java.lang.String mask, ContextManager contextManager, CallerController caller)`
    `static java.util.List<java.lang.String>` | `expandMaskToPaths(java.lang.String mask, ContextManager contextManager, CallerController caller, boolean useVisibleChildren)`
    `static java.lang.String` | `favouriteContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `favouritesContextPath(java.lang.String owner)`
    `static java.util.List<Context>` | `findChildren(java.lang.String rootsMask, java.lang.Class contextClass, ContextManager manager, CallerController caller, boolean resolveGroups)`
    `static java.util.List<Context>` | `findChildren(java.lang.String rootsMask, java.lang.String type, ContextManager manager, CallerController caller, boolean resolveGroups)`
    `static java.lang.String` | `getActualGroup(java.lang.String group)`
    `static java.lang.String` | `getAggregationContainer(java.lang.String path)`
    `static java.lang.String` | `getBaseGroup(java.lang.String group)` Returns base group name.
    `static java.lang.String` | `getBaseType(java.lang.String type)`
    `static java.lang.String` | `getChildFullName(java.lang.String parent, java.lang.String childShortName)`
    `static java.lang.String` | `getContextName(java.lang.String path)`
    `static ActionDefinition` | `getDefaultActionDefinition(Context context, CallerController caller)`
    `static java.util.Map<java.lang.String,java.lang.String>` | `getEventFields(java.lang.String mask, java.lang.String event, CallerController caller, ContextManager contextManager)`
    `static java.lang.String` | `getGroupName(java.lang.String entityName)`
    `static java.lang.String` | `getParentPath(java.lang.String path)`
    `static java.lang.String` | `getSubtype(java.lang.String type)`
    `static java.lang.String` | `getTypeForClass(java.lang.Class clazz)`
    `static java.lang.String` | `getTypeForClassSimpleName(java.lang.String name)`
    `static java.util.Map<java.lang.String,java.lang.String>` | `getVariableFields(java.lang.String mask, java.lang.String variable, CallerController caller, ContextManager contextManager)`
    `static java.lang.String` | `getVisualGroup(java.lang.String group)`
    `static java.lang.String` | `groupContextPath(java.lang.String username, java.lang.String containerContextName, java.lang.String name)`
    `static java.lang.String` | `groupsContextName(java.lang.String containerContextName)`
    `static java.lang.String` | `groupsContextPath(java.lang.String username, java.lang.String containerContextName)`
    `static boolean` | `isDerivedFrom(java.lang.String childType, java.lang.String parentType)`
    `static boolean` | `isMask(java.lang.String name)`
    `static boolean` | `isRelative(java.lang.String name)`
    `static boolean` | `isValidContextMask(java.lang.String s)`
    `static boolean` | `isValidContextName(java.lang.String s)`
    `static boolean` | `isValidContextNameChar(char c)`
    `static boolean` | `isValidContextType(java.lang.String s)`
    `static boolean` | `isValidIdentifier(java.lang.String s)`
    `static java.lang.String` | `jobContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `jobsContextPath(java.lang.String owner)`
    `static java.lang.String` | `machineLearningContextPath(java.lang.String owner)`
    `static java.lang.String` | `machineLearningContextPath(java.lang.String owner, java.lang.String name)`
    `static boolean` | `masksIntersect(java.lang.String mask1, java.lang.String mask2, boolean mask2MayExtendMask1, boolean mask1MayExtendMask2)`
    `static boolean` | `matchesToMask(java.lang.String mask, java.lang.String name)`
    `static boolean` | `matchesToMask(java.lang.String mask, java.lang.String context, boolean contextMayExtendMask, boolean maskMayExtendContext)`
    `static boolean` | `matchesToMaskWithGroups(java.lang.String mask, java.lang.String context, boolean contextMayExtendMask, boolean maskMayExtendContext, ContextManager contextManager)`
    `static boolean` | `matchesToType(java.util.Collection<java.lang.String> types, java.util.Collection<java.lang.String> requiredTypes)`
    `static boolean` | `matchesToType(java.lang.String type, java.util.Collection<java.lang.String> requiredTypes)`
    `static java.lang.String` | `modelContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `modelsContextPath(java.lang.String owner)`
    `static java.lang.String` | `pluginConfigContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `pluginGlobalConfigContextPath(java.lang.String pluginId)`
    `static java.lang.String` | `pluginIdToContextName(java.lang.String pluginId)`
    `static java.lang.String` | `pluginsUserConfigContextPath(java.lang.String username)`
    `static java.lang.String` | `pluginUserConfigContextPath(java.lang.String username, java.lang.String pluginId)`
    `static java.lang.String` | `processControlContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `processesControlContextPath(java.lang.String owner)`
    `static java.lang.String` | `queriesContextPath(java.lang.String owner)`
    `static java.lang.String` | `queryContextPath(java.lang.String owner, java.lang.String name)`
    `static void` | `registerType(java.lang.String type)`
    `static java.lang.String` | `removeContextNameFromPath(java.lang.String path)`
    `static java.lang.String` | `replaceUsernameToPattern(java.lang.String path)`
    `static java.lang.String` | `reportContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `reportsContextPath(java.lang.String owner)`
    `static java.lang.String` | `scriptContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `scriptsContextPath(java.lang.String owner)`
    `static java.lang.String` | `trackerContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `trackersContextPath(java.lang.String owner)`
    `static java.lang.String` | `uiComponentContextPath(java.lang.String owner)`
    `static java.lang.String` | `uiComponentContextPath(java.lang.String owner, java.lang.String device)`
    `static java.lang.String` | `userContextPath(java.lang.String username)`
    `static java.lang.String` | `widgetContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `widgetsContextPath(java.lang.String owner)`
    `static java.lang.String` | `workflowContextPath(java.lang.String owner, java.lang.String name)`
    `static java.lang.String` | `workflowsContextPath(java.lang.String owner)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### CONTEXT_NAME_PATTERN

          public static final java.lang.String CONTEXT_NAME_PATTERN

      See Also:
        Constant Field Values

    - #### CONTEXT_PATH_PATTERN

          public static final java.lang.String CONTEXT_PATH_PATTERN

      See Also:
        Constant Field Values

    - #### CONTEXT_MASK_PATTERN

          public static final java.lang.String CONTEXT_MASK_PATTERN

      See Also:
        Constant Field Values

    - #### CONTEXT_TYPE_PATTERN

          public static final java.lang.String CONTEXT_TYPE_PATTERN

      See Also:
        Constant Field Values

    - #### ENTITY_NAME_PATTERN

          public static final java.lang.String ENTITY_NAME_PATTERN

      See Also:
        Constant Field Values

    - #### IDENTIFIER_PATTERN

          public static final java.lang.String IDENTIFIER_PATTERN

      See Also:
        Constant Field Values

    - #### CONTEXT_NAME_SEPARATOR

          public static final java.lang.String CONTEXT_NAME_SEPARATOR

      See Also:
        Constant Field Values

    - #### CONTEXT_TYPE_SEPARATOR

          public static final java.lang.String CONTEXT_TYPE_SEPARATOR

      See Also:
        Constant Field Values

    - #### CONTEXT_GROUP_MASK

          public static final java.lang.String CONTEXT_GROUP_MASK

      See Also:
        Constant Field Values

    - #### ENTITY_GROUP_MASK

          public static final java.lang.String ENTITY_GROUP_MASK

      See Also:
        Constant Field Values

    - #### CONTEXT_TYPE_ANY

          public static final java.lang.String CONTEXT_TYPE_ANY

      See Also:
        Constant Field Values

    - #### ENTITY_ANY

          public static final java.lang.String ENTITY_ANY

      See Also:
        Constant Field Values

    - #### ENTITY_GROUP_SEPARATOR

          public static final java.lang.String ENTITY_GROUP_SEPARATOR

      See Also:
        Constant Field Values

    - #### MASK_LIST_SEPARATOR

          public static final java.lang.String MASK_LIST_SEPARATOR

      See Also:
        Constant Field Values

    - #### GROUP_DEFAULT

          public static final java.lang.String GROUP_DEFAULT

      See Also:
        Constant Field Values

    - #### GROUP_SYSTEM

          public static final java.lang.String GROUP_SYSTEM

      See Also:
        Constant Field Values

    - #### GROUP_REMOTE

          public static final java.lang.String GROUP_REMOTE

      See Also:
        Constant Field Values

    - #### GROUP_CUSTOM

          public static final java.lang.String GROUP_CUSTOM

      See Also:
        Constant Field Values

    - #### GROUP_STATUS

          public static final java.lang.String GROUP_STATUS

      See Also:
        Constant Field Values

    - #### GROUP_CONTEXT_DATA

          public static final java.lang.String GROUP_CONTEXT_DATA

      See Also:
        Constant Field Values

    - #### GROUP_ACCESS

          public static final java.lang.String GROUP_ACCESS

      See Also:
        Constant Field Values

    - #### ENTITY_ANY_TYPE

          public static final int ENTITY_ANY_TYPE

      See Also:
        Constant Field Values

    - #### ENTITY_VARIABLE

          public static final int ENTITY_VARIABLE

      See Also:
        Constant Field Values

    - #### ENTITY_FUNCTION

          public static final int ENTITY_FUNCTION

      See Also:
        Constant Field Values

    - #### ENTITY_EVENT

          public static final int ENTITY_EVENT

      See Also:
        Constant Field Values

    - #### ENTITY_ACTION

          public static final int ENTITY_ACTION

      See Also:
        Constant Field Values

    - #### ENTITY_INSTANCE

          public static final int ENTITY_INSTANCE

      See Also:
        Constant Field Values

    - #### ENTITY_GROUP_SHIFT

          public static final int ENTITY_GROUP_SHIFT

      See Also:
        Constant Field Values

    - #### ENTITY_VARIABLE_GROUP

          public static final int ENTITY_VARIABLE_GROUP

      See Also:
        Constant Field Values

    - #### ENTITY_FUNCTION_GROUP

          public static final int ENTITY_FUNCTION_GROUP

      See Also:
        Constant Field Values

    - #### ENTITY_EVENT_GROUP

          public static final int ENTITY_EVENT_GROUP

      See Also:
        Constant Field Values

    - #### ENTITY_ACTION_GROUP

          public static final int ENTITY_ACTION_GROUP

      See Also:
        Constant Field Values

    - #### USERNAME_PATTERN

          public static final java.lang.String USERNAME_PATTERN

      See Also:
        Constant Field Values

    - #### VARIABLES_GROUP_DS_SETTINGS

          public static final java.lang.String VARIABLES_GROUP_DS_SETTINGS

      See Also:
        Constant Field Values

    - #### ENTITY_GROUP_SUFFIX

          public static final java.lang.String ENTITY_GROUP_SUFFIX

      See Also:
        Constant Field Values

    - #### SRV_MORE_CONTEXT

          public static final java.lang.String SRV_MORE_CONTEXT

      See Also:
        Constant Field Values

    - #### RESERVED_CONTEXT_NAMES

          public static final java.util.Set<java.lang.String> RESERVED_CONTEXT_NAMES

    - #### CONTEXT_TYPES

          public static final java.util.Set<java.lang.String> CONTEXT_TYPES

  - ### Constructor Detail

    - #### ContextUtils

          public ContextUtils()

  - ### Method Detail

    - #### userContextPath

          public static java.lang.String userContextPath(java.lang.String username)

    - #### deviceServersContextPath

          public static java.lang.String deviceServersContextPath(java.lang.String owner)

    - #### dsGroupsContextPath

          public static java.lang.String dsGroupsContextPath(java.lang.String owner)

    - #### dsGroupContextPath

          public static java.lang.String dsGroupContextPath(java.lang.String owner,
                                                            java.lang.String name)

    - #### deviceGroupsContextPath

          public static java.lang.String deviceGroupsContextPath(java.lang.String owner)

    - #### deviceGroupContextPath

          public static java.lang.String deviceGroupContextPath(java.lang.String owner,
                                                                java.lang.String name)

    - #### groupContextPath

          public static java.lang.String groupContextPath(java.lang.String username,
                                                          java.lang.String containerContextName,
                                                          java.lang.String name)

    - #### groupsContextPath

          public static java.lang.String groupsContextPath(java.lang.String username,
                                                           java.lang.String containerContextName)

    - #### groupsContextName

          public static java.lang.String groupsContextName(java.lang.String containerContextName)

    - #### alertContextPath

          public static java.lang.String alertContextPath(java.lang.String owner,
                                                          java.lang.String name)

    - #### alertsContextPath

          public static java.lang.String alertsContextPath(java.lang.String owner)

    - #### jobsContextPath

          public static java.lang.String jobsContextPath(java.lang.String owner)

    - #### jobContextPath

          public static java.lang.String jobContextPath(java.lang.String owner,
                                                        java.lang.String name)

    - #### queriesContextPath

          public static java.lang.String queriesContextPath(java.lang.String owner)

    - #### queryContextPath

          public static java.lang.String queryContextPath(java.lang.String owner,
                                                          java.lang.String name)

    - #### compliancePoliciesContextPath

          public static java.lang.String compliancePoliciesContextPath(java.lang.String owner)

    - #### compliancePolicyContextPath

          public static java.lang.String compliancePolicyContextPath(java.lang.String owner,
                                                                     java.lang.String name)

    - #### reportsContextPath

          public static java.lang.String reportsContextPath(java.lang.String owner)

    - #### reportContextPath

          public static java.lang.String reportContextPath(java.lang.String owner,
                                                           java.lang.String name)

    - #### trackersContextPath

          public static java.lang.String trackersContextPath(java.lang.String owner)

    - #### trackerContextPath

          public static java.lang.String trackerContextPath(java.lang.String owner,
                                                            java.lang.String name)

    - #### commonDataContextPath

          public static java.lang.String commonDataContextPath(java.lang.String owner)

    - #### commonTableContextPath

          public static java.lang.String commonTableContextPath(java.lang.String owner,
                                                                java.lang.String name)

    - #### eventFiltersContextPath

          public static java.lang.String eventFiltersContextPath(java.lang.String owner)

    - #### eventFilterContextPath

          public static java.lang.String eventFilterContextPath(java.lang.String owner,
                                                                java.lang.String name)

    - #### widgetContextPath

          public static java.lang.String widgetContextPath(java.lang.String owner,
                                                           java.lang.String name)

    - #### widgetsContextPath

          public static java.lang.String widgetsContextPath(java.lang.String owner)

    - #### processControlContextPath

          public static java.lang.String processControlContextPath(java.lang.String owner,
                                                                   java.lang.String name)

    - #### processesControlContextPath

          public static java.lang.String processesControlContextPath(java.lang.String owner)

    - #### machineLearningContextPath

          public static java.lang.String machineLearningContextPath(java.lang.String owner,
                                                                    java.lang.String name)

    - #### machineLearningContextPath

          public static java.lang.String machineLearningContextPath(java.lang.String owner)

    - #### dashboardsContextPath

          public static java.lang.String dashboardsContextPath(java.lang.String owner)

    - #### dashboardContextPath

          public static java.lang.String dashboardContextPath(java.lang.String owner,
                                                              java.lang.String name)

    - #### autorunActionsContextPath

          public static java.lang.String autorunActionsContextPath(java.lang.String owner)

    - #### autorunActionContextName

          public static java.lang.String autorunActionContextName(java.lang.String owner,
                                                                  java.lang.String name)

    - #### favouritesContextPath

          public static java.lang.String favouritesContextPath(java.lang.String owner)

    - #### favouriteContextPath

          public static java.lang.String favouriteContextPath(java.lang.String owner,
                                                              java.lang.String name)

    - #### scriptContextPath

          public static java.lang.String scriptContextPath(java.lang.String owner,
                                                           java.lang.String name)

    - #### scriptsContextPath

          public static java.lang.String scriptsContextPath(java.lang.String owner)

    - #### modelsContextPath

          public static java.lang.String modelsContextPath(java.lang.String owner)

    - #### modelContextPath

          public static java.lang.String modelContextPath(java.lang.String owner,
                                                          java.lang.String name)

    - #### eventCorrelatorsContextPath

          public static java.lang.String eventCorrelatorsContextPath(java.lang.String owner)

    - #### eventCorrelatorContextPath

          public static java.lang.String eventCorrelatorContextPath(java.lang.String owner,
                                                                    java.lang.String name)

    - #### classesContextPath

          public static java.lang.String classesContextPath(java.lang.String owner)

    - #### classContextPath

          public static java.lang.String classContextPath(java.lang.String owner,
                                                          java.lang.String name)

    - #### workflowsContextPath

          public static java.lang.String workflowsContextPath(java.lang.String owner)

    - #### workflowContextPath

          public static java.lang.String workflowContextPath(java.lang.String owner,
                                                             java.lang.String name)

    - #### deviceServerContextPath

          public static java.lang.String deviceServerContextPath(java.lang.String owner,
                                                                 java.lang.String name)

    - #### pluginGlobalConfigContextPath

          public static java.lang.String pluginGlobalConfigContextPath(java.lang.String pluginId)

    - #### pluginsUserConfigContextPath

          public static java.lang.String pluginsUserConfigContextPath(java.lang.String username)

    - #### pluginUserConfigContextPath

          public static java.lang.String pluginUserConfigContextPath(java.lang.String username,
                                                                     java.lang.String pluginId)

    - #### pluginConfigContextPath

          public static java.lang.String pluginConfigContextPath(java.lang.String owner,
                                                                 java.lang.String name)

    - #### devicesContextPath

          public static java.lang.String devicesContextPath(java.lang.String owner)

    - #### deviceContextPath

          public static java.lang.String deviceContextPath(java.lang.String owner,
                                                           java.lang.String device)

    - #### uiComponentContextPath

          public static java.lang.String uiComponentContextPath(java.lang.String owner)

    - #### uiComponentContextPath

          public static java.lang.String uiComponentContextPath(java.lang.String owner,
                                                                java.lang.String device)

    - #### applicationContextPath

          public static java.lang.String applicationContextPath(java.lang.String owner,
                                                                java.lang.String name)

    - #### applicationsContextPath

          public static java.lang.String applicationsContextPath(java.lang.String owner)

    - #### applicationsContextPathByUserContext

          public static java.lang.String applicationsContextPathByUserContext(java.lang.String userContextPath)

    - #### getAggregationContainer

          public static java.lang.String getAggregationContainer(java.lang.String path)

    - #### replaceUsernameToPattern

          public static java.lang.String replaceUsernameToPattern(java.lang.String path)

    - #### removeContextNameFromPath

          public static java.lang.String removeContextNameFromPath(java.lang.String path)

    - #### createName

          public static java.lang.String createName(java.lang.String... parts)

    - #### createGroup

          public static java.lang.String createGroup(java.lang.String... parts)

    - #### pluginIdToContextName

          public static java.lang.String pluginIdToContextName(java.lang.String pluginId)

    - #### getChildFullName

          public static java.lang.String getChildFullName(java.lang.String parent,
                                                          java.lang.String childShortName)

    - #### contextPathToContextName

          public static java.lang.String contextPathToContextName(java.lang.String path)

    - #### expandMaskListToContexts

          public static java.util.List<Context> expandMaskListToContexts(java.lang.String masks,
                                                                         ContextManager contextManager)

    - #### expandMaskListToContexts

          public static java.util.List<Context> expandMaskListToContexts(java.lang.String masks,
                                                                         ContextManager contextManager,
                                                                         CallerController caller)

    - #### expandMaskListToContexts

          public static java.util.List<Context> expandMaskListToContexts(java.lang.String masks,
                                                                         ContextManager contextManager,
                                                                         CallerController caller,
                                                                         boolean useVisibleChildren)

    - #### expandMaskToContexts

          public static java.util.List<Context> expandMaskToContexts(java.lang.String mask,
                                                                     ContextManager contextManager)

    - #### expandMaskToContexts

          public static java.util.List<Context> expandMaskToContexts(java.lang.String mask,
                                                                     ContextManager contextManager,
                                                                     CallerController caller)

    - #### expandMaskToContexts

          public static java.util.List<Context> expandMaskToContexts(java.lang.String mask,
                                                                     ContextManager contextManager,
                                                                     CallerController caller,
                                                                     boolean useVisibleChildren)

    - #### expandMaskToPaths

          public static java.util.List<java.lang.String> expandMaskToPaths(java.lang.String mask,
                                                                           ContextManager contextManager)

    - #### expandMaskToPaths

          public static java.util.List<java.lang.String> expandMaskToPaths(java.lang.String mask,
                                                                           ContextManager contextManager,
                                                                           CallerController caller)

    - #### expandMaskToPaths

          public static java.util.List<java.lang.String> expandMaskToPaths(java.lang.String mask,
                                                                           ContextManager contextManager,
                                                                           CallerController caller,
                                                                           boolean useVisibleChildren)

    - #### findChildren

          public static java.util.List<Context> findChildren(java.lang.String rootsMask,
                                                             java.lang.Class contextClass,
                                                             ContextManager manager,
                                                             CallerController caller,
                                                             boolean resolveGroups)

    - #### findChildren

          public static java.util.List<Context> findChildren(java.lang.String rootsMask,
                                                             java.lang.String type,
                                                             ContextManager manager,
                                                             CallerController caller,
                                                             boolean resolveGroups)

    - #### matchesToMask

          public static boolean matchesToMask(java.lang.String mask,
                                              java.lang.String name)

    - #### matchesToType

          public static boolean matchesToType(java.lang.String type,
                                              java.util.Collection<java.lang.String> requiredTypes)

    - #### matchesToType

          public static boolean matchesToType(java.util.Collection<java.lang.String> types,
                                              java.util.Collection<java.lang.String> requiredTypes)

    - #### matchesToMaskWithGroups

          public static boolean matchesToMaskWithGroups(java.lang.String mask,
                                                        java.lang.String context,
                                                        boolean contextMayExtendMask,
                                                        boolean maskMayExtendContext,
                                                        ContextManager contextManager)

    - #### matchesToMask

          public static boolean matchesToMask(java.lang.String mask,
                                              java.lang.String context,
                                              boolean contextMayExtendMask,
                                              boolean maskMayExtendContext)

    - #### masksIntersect

          public static boolean masksIntersect(java.lang.String mask1,
                                               java.lang.String mask2,
                                               boolean mask2MayExtendMask1,
                                               boolean mask1MayExtendMask2)

    - #### isRelative

          public static boolean isRelative(java.lang.String name)

    - #### isMask

          public static boolean isMask(java.lang.String name)

    - #### isValidContextType

          public static boolean isValidContextType(java.lang.String s)

    - #### isValidContextName

          public static boolean isValidContextName(java.lang.String s)

    - #### isValidContextMask

          public static boolean isValidContextMask(java.lang.String s)

    - #### isValidIdentifier

          public static boolean isValidIdentifier(java.lang.String s)

    - #### isDerivedFrom

          public static boolean isDerivedFrom(java.lang.String childType,
                                              java.lang.String parentType)

    - #### getParentPath

          public static java.lang.String getParentPath(java.lang.String path)

    - #### getContextName

          public static java.lang.String getContextName(java.lang.String path)

    - #### getBaseGroup

          public static java.lang.String getBaseGroup(java.lang.String group)

      Returns base group name. Useful for composite group names that contain several group names delimited with group separator symbol.

    - #### getActualGroup

          public static java.lang.String getActualGroup(java.lang.String group)

    - #### getVisualGroup

          public static java.lang.String getVisualGroup(java.lang.String group)

    - #### getBaseType

          public static java.lang.String getBaseType(java.lang.String type)

    - #### getSubtype

          public static java.lang.String getSubtype(java.lang.String type)

    - #### getTypeForClass

          public static java.lang.String getTypeForClass(java.lang.Class clazz)

    - #### getTypeForClassSimpleName

          public static java.lang.String getTypeForClassSimpleName(java.lang.String name)

    - #### getEventFields

          public static java.util.Map<java.lang.String,java.lang.String> getEventFields(java.lang.String mask,
                                                                                        java.lang.String event,
                                                                                        CallerController caller,
                                                                                        ContextManager contextManager)

    - #### getVariableFields

          public static java.util.Map<java.lang.String,java.lang.String> getVariableFields(java.lang.String mask,
                                                                                           java.lang.String variable,
                                                                                           CallerController caller,
                                                                                           ContextManager contextManager)

    - #### getDefaultActionDefinition

          public static ActionDefinition getDefaultActionDefinition(Context context,
                                                                    CallerController caller)

    - #### createType

          public static java.lang.String createType(java.lang.Class clazz,
                                                    java.lang.String deviceType)

    - #### isValidContextNameChar

          public static boolean isValidContextNameChar(char c)

    - #### changeVariable

          public static void changeVariable(Context aContext,
                                            java.lang.String variableNameString,
                                            ContextUtils.ModifyVariable modifications)
                                     throws ContextException

      Throws:
        `ContextException`

    - #### getGroupName

          public static java.lang.String getGroupName(java.lang.String entityName)

    - #### registerType

          public static void registerType(java.lang.String type)